SystemOrganization addCategory: #'Idiom-Exercise'!

TestCase subclass: #IdiomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!IdiomTest methodsFor: 'testing' stamp: 'Julian 5/9/2012 20:27'!
calculateIfTimeFrom: addOrDeleteCustomer isLessThan: aTime
	
	| startTime endTime |
	
	startTime := Time millisecondClockValue.
	addOrDeleteCustomer value.
	endTime := Time millisecondClockValue.
	
	self assert: (endTime - startTime) < aTime. ! !

!IdiomTest methodsFor: 'testing' stamp: 'Julian 5/9/2012 20:25'!
test01AddingCustomerShouldNotTakeMoreThan50Milliseconds
	| customerBook addTime|

	customerBook := CustomerBook  new.

	self calculateIfTimeFrom:  [customerBook addCustomerNamed: 'John Lennon'] isLessThan: 50
	 

	
	
! !

!IdiomTest methodsFor: 'testing' stamp: 'Julian 5/9/2012 20:30'!
test02RemovingCustomerShouldNotTakeMoreThan100Milliseconds

	| customerBook millisecondsBeforeRunning millisecondsAfterRunning johnLennon |
	
	customerBook := CustomerBook  new.
	johnLennon := 'John Lennon'.
	
	customerBook addCustomerNamed: johnLennon.
	
	self calculateIfTimeFrom: [customerBook removeCustomerNamed: johnLennon] isLessThan: 100! !

!IdiomTest methodsFor: 'testing' stamp: 'Julian 5/9/2012 21:01'!
test03CanNotAddACustomerWithEmptyName 

	| customerBook |
			
	customerBook := CustomerBook new.

	self xxxx: [customerBook addCustomerNamed: '']
		 yyyy: Error
		 zzzz: [ :anError | 
				self assert: anError messageText = CustomerBook customerCanNotBeEmptyErrorMessage.
				self assert: customerBook isEmpty ]! !

!IdiomTest methodsFor: 'testing' stamp: 'Julian 5/9/2012 20:58'!
test04CanNotAddRepeatedCustomer 
	
	| customerBook johnLennon |
			
	customerBook := CustomerBook new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.
	
	self xxxx: [ customerBook removeCustomerNamed: 'Paul McCartney']
		 yyyy: NotFound
		 zzzz: [ :anError | 
				self assert: customerBook numberOfCustomers = 1.
				self assert: (customerBook includesCustomerNamed: johnLennon) ].! !

!IdiomTest methodsFor: 'testing' stamp: 'Julian 5/9/2012 20:59'!
xxxx: aBlock yyyy: onError zzzz: onErrorBlock

	[aBlock value. self fail]
		on: onError
		do: onErrorBlock ! !

Object subclass: #CustomerBook
	instanceVariableNames: 'customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:57'!
customerAlreadyExistsErrorMessage

	^'Customer already exists'! !

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:53'!
customerCanNotBeEmptyErrorMessage

	^'Customer name cannot be empty'! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:42'!
addCustomerNamed: aName

	aName isEmpty ifTrue: [ self signalCustomerNameCannotBeEmpty ].
	(customers includes: aName) ifTrue: [ self signalCustomerAlreadyExists ].
	
	customers add: aName ! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:56'!
includesCustomerNamed: aName

	^customers includes: aName ! !

!CustomerBook methodsFor: 'initialization' stamp: 'HernanWilkinson 7/6/2011 17:42'!
initialize

	super initialize.
	customers := OrderedCollection new! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:48'!
isEmpty
	
	^customers isEmpty  ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:56'!
numberOfCustomers
	
	^customers size! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:44'!
removeCustomerNamed: aName
 
	customers remove: aName ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:52'!
signalCustomerAlreadyExists 

	self error: self class customerAlreadyExistsErrorMessage! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:51'!
signalCustomerNameCannotBeEmpty 

	self error: self class customerCanNotBeEmptyErrorMessage ! !
